﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Patterns
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            // 7
            button1.Click += button1_Click;
            button1.Click += test;
            //button1.Click -= test;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            StateContext a = new StateContext();
            a.Tick();
            a.Tick();
            a.Tick();

            // 8
            Machine m = new Machine();
            m.Overheated += report;
            m.SetTemperature(50.0);
            m.SetTemperature(150.0);
        }
        // 8
        void report(object sender, EventArgs e)
        {
            MessageBox.Show("Zu heiß!");
        }

        private void test(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("edtgzudxuj");
        }
    }

    //1
    class Singleton
    {
        Singleton() // also private! 
        { }
        static Singleton instance;
        public static Singleton GetInstance()
        {
            if (instance == null) // lazy initialization
            {
                instance = new Singleton();
            }
            return instance;
        }
    }

    //3
    abstract class Component
    {
        public abstract void Move(double x, double y);
    }
    class Rectangle : Component
    {
        public override void Move(double x, double y)
        { //...
        }
    }
    class Composite : Component
    {
        List<Component> components = new List<Component>();
        public void Add(Component component)
        {
            components.Add(component);
        }
        public override void Move(double x, double y)
        { //...
        }
    }

    // 4
    class StateContext
    {
        State theState = new Red();

        public void Tick()
        {
            theState.Tick(this);
        }

        public void SetState(State s)
        {
            theState = s;
        }
    }
    abstract class State
    {
        public virtual void Tick(StateContext context)
        {}
    }
    class Red : State
    {
        public override void Tick(StateContext context)
        {
            context.SetState(new RedAndAmber());
        }
    }
    class RedAndAmber : State
    {
        public override void Tick(StateContext context)
        {
            context.SetState(new Green());
        }
    }
    class Green : State
    {
        public override void Tick(StateContext context)
        {
            context.SetState(new Amber());
        }
    }
    class Amber : State
    {
        public override void Tick(StateContext context)
        {
            context.SetState(new Red());
        }
    }

    //8
    class Machine
    {
        public event EventHandler<EventArgs> Overheated;

        public void SetTemperature(double t)
        {
            if (t > 100.0)
            {
                if (Overheated != null)
                {
                    Overheated(this, new EventArgs());
                }
            }
        }
    }
}
